import java.io.*;
import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;

public class ClientRegKeyPair {

    private PublicKey           clientregPublicKey;
    private PrivateKey          clientregPrivateKey;
    private byte[]              clientregEncodedPublicKey;

    public ClientRegKeyPair() {
        try {
            // ClientReg's public/private keys generator
            // This will be replaced by reading keys from keys repository
            KeyPairGenerator clientregKeyGen = KeyPairGenerator.getInstance("DSA");
            clientregKeyGen.initialize(1024, new SecureRandom());
            KeyPair kPair = clientregKeyGen.generateKeyPair();
            clientregPublicKey = kPair.getPublic();
            clientregPrivateKey = kPair.getPrivate();
            clientregEncodedPublicKey = clientregPublicKey.getEncoded();

            // String st = toHexString(clientregEncodedPublicKey);
            // System.err.println("ClientReg's Encoded PublicKey: " + st);
        } catch (Exception ex) {
            System.err.println("ClientRegKeyPair Exception-> " + ex);
        }
    }

    public byte[] getEncodedPublicKey() {
        if (this.clientregEncodedPublicKey == null)
            System.err.println("Error");
        return this.clientregEncodedPublicKey;
    }

    public PublicKey getPublicKey() {
        return this.clientregPublicKey;
    }

    public PrivateKey getPrivateKey() {
        return this.clientregPrivateKey;
    }
}
